' import_kuerzel.vbs V1.2
'*********************************************************
' (C) Zaph 06/2003
' Email: zaphl@gmx.de
' Ohne Gewhr, keine Haftung!
'
' Tastaturkrzel fr Fixfoto laden
' Fixfoto: http://www.j-k-s.com
'*********************************************************
' import_kuerzel.vbs ldt die Tastaturkrzelbelegung
' aus der Datei [FixfotoInstallationsverzeichnis]\keys.ini
' in die Registry. Diese Datei wird durch export_kuerzel.vbs erzeugt.
' Vorhandene Eintrge (Krzel) werden nicht berschrieben.
' Der vor dem Aufruf vorhandene Schlssel wird als
' Sicherheitskopie in [FixfotoInstallationsverzeichnis]\keys-backup.reg
' gespeichert und kann per Doppelklick eingelesen werden.
'
' Aufruf: Doppelklick auf diese Datei im Explorer
'
' Der Aufruf ist nur dann sinnvoll, wenn Fixfoto nicht luft!!
'
' nderungen:
' 18.03.2004  V1.1  Anpassungen an FF 2.75
' 16.05.2004  V1.2  Ermittlung des Installationspfades repariert

option explicit

Const ForReading = 1, ForWriting = 2

dim wsShell, fso
set wsShell = CreateObject("WScript.Shell")
set fso = CreateObject("Scripting.FileSystemObject")

main

set fso = nothing
set wsShell = nothing
' Ende

sub main
	Dim KeyFile, KeyFileName, regFileName
	dim FFPath, keys, i, ik, msg, line
	dim bb

	On Error Resume Next

	FFPath = GetFFInstPath
	if FFPath ="" then
		msgbox "Abbruch - Fixfoto-Installationsverzeichnis nicht in Registry gefunden!", VBExclamation
		exit sub
	end if

	keys = wsShell.RegRead("HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Settings\BCGKeyboard-0\Accelerators")
	if Err.number <> 0 then
		msgbox "Abbruch - BCG Settings nicht in Registry gefunden!", VBExclamation
		exit sub
	end if

	regFileName = FFPath & "\keys-bakup.reg"
	WriteRegFile regFileName, keys

	KeyFileName = FFPath & "\keys.ini"
	if fso.FileExists(KeyFileName) = false then
		msgbox "Abbruch - " & KeyFileName & " nicht gefunden!", VBExclamation
		exit sub
	end if

	on error goto 0

	Set KeyFile = fso.OpenTextFile(KeyFileName, ForReading, True)
	ik = 0
	Do While KeyFile.AtEndOfStream <> True
		line = KeyFile.ReadLine
		if trim(line) <> "" then
			bb = Split(line, ",", -1)
			if ImportKey(keys, bb) then ik=ik+1
		end if
	Loop
	KeyFile.Close

	regFileName = FFPath & "\keys.reg"
	WriteRegFile regFileName, keys

	if ik = 0 then
		msgbox "Keine neuen Tastaturkrzel aus " & KeyFileName & " importiert!"
		exit sub
	end if

	msgbox ik & " Tastaturkrzel fertig zum Import!" & VBCrLf & "Bitte folgende Abfrage mit Ja besttigen!", VBInformation
	wsShell.Run regFileName

end sub

function ImportKey(byref keys, bb)
	dim i,ub
	ub = ubound(keys)
	for i=0 to ub-5 step 6
		if keys(i)=cint(bb(0)) and keys(i+1)=cint(bb(1)) and keys(i+2)=cint(bb(2)) _
		and keys(i+3)=cint(bb(3)) and keys(i+4)=cint(bb(4)) and keys(i+5)=cint(bb(5)) then
'			msgbox chr(bb(2)) & " gefunden + bersprungen"
			ImportKey = false
			exit function
		end if
	next
	redim preserve keys(ub+6)
	keys(ub+1) = cint(bb(0))
	keys(ub+2) = cint(bb(1))
	keys(ub+3) = cint(bb(2))
	keys(ub+4) = cint(bb(3))
	keys(ub+5) = cint(bb(4))
	keys(ub+6) = cint(bb(5))
'	msgbox chr(bb(2)) & " angehngt"
	ImportKey = true

end function

function WriteRegFile(regFileName, keys)
	dim i,ub
	dim regFile

	ub = ubound(keys)
	Set regFile = fso.OpenTextFile(regFileName, ForWriting, True)
	if Err.number <> 0 then
		msgbox "Abbruch - Kann " & regFileName & " nicht zum Schreiben ffnen!", VBExclamation
		exit function
	end if
	regFile.writeLine "REGEDIT4"
	regFile.WriteBlankLines(1)
	regFile.writeLine "[" & "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Settings\BCGKeyboard-0" & "]"
	regFile.writeLine """Accelerators""=hex:\"
	for i=0 to ub-5 step 6
		regFile.write "  " & dhex(keys(i)) & "," & dhex(keys(i+1)) & "," & dhex(keys(i+2)) & _
		"," & dhex(keys(i+3)) & "," & dhex(keys(i+4)) & "," & dhex(keys(i+5))
		if i < ub-5 then
			regFile.writeLine ",\"
		else
			regFile.WriteBlankLines(2)
		end if
	next

	regFile.Close

end function

Function dhex(num)
	dhex=lcase(right("0" & hex(num),2))
end Function

Function GetFFInstPath
	' ermittelt den Installationspfad von Fixfoto
	On Error Resume Next

	GetFFInstPath = wsShell.RegRead("HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\DataPath")
	if Err.number = 0 Then Exit Function
	Err.number = 0
	GetFFInstPath = ""

End Function